//play.js

var playState = {
	player: null,
	buisson: null,
	catchedRVW: 0,
	directionX: [505,380,305,505,245,205,570],
	directionY: [215,290,215,415,390,290,290],
	
	create: function () {
		var background = game.add.sprite(0, 0, 'background');
		var self = this;
		
		self.player = Player();
		game.add.existing(self.player);
		//game.input.activePointer.capture = true;
		game.physics.enable(self.player, Phaser.Physics.ARCADE);
		self.player.inputEnabled = true;
		self.player.input.pixelPerfectClick = true;
		self.player.events.onInputDown.add(this.touchedRVW, this);
		
		self.buisson = game.add.group();
		self.buisson.add(Buisson(450, 150, 0));
		self.buisson.add(Buisson(325, 225, 1));
		self.buisson.add(Buisson(250, 150, 2));
		self.buisson.add(Buisson(450, 350, 3));
		self.buisson.add(Buisson(190, 325, 4));
		self.buisson.add(Buisson(150, 225, 5));
		self.buisson.add(Buisson(515, 225, 6));
		
		/*self.buisson.forEach(function(b, index){
			game.physics.enable(b, Phaser.Physics.P2);
			
			//b.body.moves = false;
			//b.body.embedded = true;
			//b.body.immovable = true;
			//buisson.body.blocked.up = true;
			//buisson.body.blocked.down = true;
			//buisson.body.blocked.left = true;
			//buisson.body.blocked.right = true;
			
		});*/
		
		game.time.events.loop(Phaser.Timer.SECOND*4, this.timedMoveRVW, this);
		
	},
	update: function () {
		
		var self = this;

		/*** colision detection ***/
		game.physics.arcade.collide(self.player, self.buisson, function(p,b){
			b.animations.play('bruissement');
			});
		
		self.moveRVW();
	},
	moveRVW: function () {
		var self = this;
		var percentSize = self.player.y/450;
		
		if( Math.floor( self.player.x/10 ) == Math.floor( self.player.xDest/10 ) ){
			self.player.body.velocity.x = 1;
		}else if( Math.floor( self.player.x/10 ) < Math.floor( self.player.xDest/10 ) ){
			self.player.body.velocity.x = 200;
		self.player.animations.play('run');
			self.player.scale.x = 1 * percentSize;
		}else if( Math.floor( self.player.x/10 ) > Math.floor( self.player.xDest/10 ) ){
			self.player.body.velocity.x = -200;
			self.player.animations.play('run');
			self.player.scale.x = -1 * percentSize;
		}
		
		if( Math.floor( self.player.y/10 ) == Math.floor( self.player.yDest/10 ) ){
			self.player.body.velocity.y = 1;
		}else if( Math.floor( self.player.y/10 ) < Math.floor( self.player.yDest/10 ) ){
			self.player.body.velocity.y = 165;
		  self.player.animations.play('run');
		}else if( Math.floor( self.player.y/10 ) > Math.floor( self.player.yDest/10 ) ){
			self.player.body.velocity.y = -165;
			self.player.animations.play('run');
		}
		self.player.scale.y = percentSize;
		
	},
	timedMoveRVW: function(){
		var self = this;
		rand = Math.floor(7*Math.random())
		self.player.xDest = self.directionX[rand];
		self.player.yDest = self.directionY[rand];
	},
	touchedRVW: function(){
		var self = this;
		self.player.xDest = self.player.x;
		self.player.yDest = self.player.y;
		self.player.animations.play('stop');
		self.catchedRVW++;
		if( self.catchedRVW > 15 ){
			window.location = "http://www.google.com";
			}
		}
};

function Buisson(x ,y, frame){
	
	var buisson = game.add.sprite(x, y, 'buisson');
	buisson.frame = frame;
	
	//game.physics.enable(buisson, Phaser.Physics.ARCADE);
	//buisson.body.moves = false;
	//buisson.body.embedded = true;
	
	buisson.animations.add('bruissement', [0,1,2,3], 10)
	
	return buisson;
	
}

function Player(){
	
	var player = game.add.sprite(150, 300, 'character-RVW');
						
	player.frame = 0;
	player.anchor.setTo(.5, 1);	
		
	player.animations.add('wait', [0], 4);
	player.animations.add('run', [1,2,3], 10);
	player.animations.add('stop', [4,5], 10);
	/*** first move of Rip Van Wikle ***/
	player.xDest = 505;
	player.yDest = 215;
	player.animations.play('run');
		
	return player;
	
}